searchNodes=[{"doc":"Functions and features to help Elixir applications more easily take advantage of the features that Fly.io provides.","ref":"Fly.html","title":"Fly","type":"module"},{"doc":"Return if the app instance is running in the primary region or not. Boolean result.","ref":"Fly.html#is_primary?/0","title":"Fly.is_primary?/0","type":"function"},{"doc":"Return the configured current region. Reads the FLY_REGION ENV setting that's available when deployed on the Fly.io platform. If not set, it returns &quot;local&quot; .","ref":"Fly.html#my_region/0","title":"Fly.my_region/0","type":"function"},{"doc":"Return the configured primary region. Reads and requires an ENV setting for PRIMARY_REGION . If not set, it returns &quot;local&quot; .","ref":"Fly.html#primary_region/0","title":"Fly.primary_region/0","type":"function"},{"doc":"Execute the MFA on a node in the primary region.","ref":"Fly.html#rpc_primary/4","title":"Fly.rpc_primary/4","type":"function"},{"doc":"Provides an RPC interface for executing an MFA on a node within a region. Configuration Assumes each node is running the Fly.RPC server in its supervision tree and exports FLY_REGION environment variable to identify the fly region. To run code on a specific region call rpc_region/4 . A node found within the given region will be chosen at random. Raises if no nodes exist on the given region. The special :primary region may be passed to run the rpc against the region identified by the PRIMARY_REGION environment variable. Examples &gt; rpc_region ( &quot;hkg&quot; , String , :upcase , [ &quot;fly&quot; ] ) &quot;FLY&quot; &gt; rpc_region ( Fly . primary_region ( ) , String , :upcase , [ &quot;fly&quot; ] ) &quot;FLY&quot; &gt; rpc_region ( :primary , String , :upcase , [ &quot;fly&quot; ] ) &quot;FLY&quot; Server The GenServer's responsibility is just to monitor other nodes as they enter and leave the cluster. It maintains a list of nodes and the Fly.io region where they are deployed in an ETS table that other processes can use to find and initiate their own RPC calls to.","ref":"Fly.RPC.html","title":"Fly.RPC","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Fly.RPC.html#child_spec/1","title":"Fly.RPC.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.handle_continue/2 .","ref":"Fly.RPC.html#handle_continue/2","title":"Fly.RPC.handle_continue/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Fly.RPC.html#init/1","title":"Fly.RPC.init/1","type":"function"},{"doc":"Executes a function on the remote node to determine if the RPC API support is available. Support may not exist on the remote node in a &quot;first roll out&quot; scenario.","ref":"Fly.RPC.html#is_rpc_supported?/1","title":"Fly.RPC.is_rpc_supported?/1","type":"function"},{"doc":"Asks a node what Fly region it's running in. Returns :error if RPC is not supported on remote node.","ref":"Fly.RPC.html#region/1","title":"Fly.RPC.region/1","type":"function"},{"doc":"Returns the Elixir OTP nodes registered the region. Reads from a local cache.","ref":"Fly.RPC.html#region_nodes/2","title":"Fly.RPC.region_nodes/2","type":"function"},{"doc":"Executes the function on the remote node and waits for the response. Exits after timeout milliseconds.","ref":"Fly.RPC.html#rpc/5","title":"Fly.RPC.rpc/5","type":"function"},{"doc":"Executes the MFA on an available node in the desired region. If the region is the &quot;primary&quot; region or the &quot;local&quot; region then execute the function immediately. Supports the string name of the region or :primary for the current configured primary region. Otherwise find an available node and select one at random to execute the function. Raises ArgumentError when no available nodes. Example &gt; RPC . rpc_region ( &quot;hkg&quot; , Kernel , :+ , [ 1 , 2 ] ) 3 &gt; RPC . rpc_region ( :primary , Kernel , :+ , [ 1 , 2 ] ) 3","ref":"Fly.RPC.html#rpc_region/5","title":"Fly.RPC.rpc_region/5","type":"function"},{"doc":"","ref":"Fly.RPC.html#start_link/1","title":"Fly.RPC.start_link/1","type":"function"},{"doc":"","ref":"Fly.RPC.html#t:region/0","title":"Fly.RPC.region/0","type":"type"},{"doc":"","ref":"Fly.RPC.html#t:tab/0","title":"Fly.RPC.tab/0","type":"type"},{"doc":"Fly RPC Helps a clustered Elixir application know what Fly.io region it is deployed in, if that is the primary region, and provides features for executing a function through RPC (Remote Procedure Call) on another node by specifying the region to run it in. Online Documentation","ref":"readme.html","title":"Fly RPC","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding fly_rpc to your list of dependencies in mix.exs : def deps do [ { :fly_rpc , &quot;~&gt; 0.1.0&quot; } ] end Through ENV configuration, you can to tell the app which region is the &quot;primary&quot; region. fly.toml This example configuration says that the Sydney Australia region is the &quot;primary&quot; region. [env] PRIMARY_REGION = &quot;syd&quot; Add Fly.RPC to your application's supervision tree. defmodule MyApp.Application do use Application def start ( _type , _args ) do # ... children = [ # Start the RPC server { Fly.RPC , [ ] } , #... ] # ... end end This starts a GenServer that reaches out to other nodes in the cluster to learn what Fly.io regions they are located in. The GenServer caches those results in a local ETS table for fast access.","ref":"readme.html#installation","title":"Fly RPC - Installation","type":"extras"},{"doc":"The Fly.io platform already provides and ENV value of FLY_REGION which this library accesses. Fly . primary_region ( ) #=&gt; &quot;syd&quot; Fly . current_region ( ) #=&gt; &quot;lax&quot; Fly . is_primary? ( ) #=&gt; false The real benefit comes in using the Fly.RPC module. Fly.RPC . rpc_region ( &quot;hkg&quot; , String , :upcase , [ &quot;fly&quot; ] ) #=&gt; &quot;FLY&quot; Fly.RPC . rpc_region ( Fly . primary_region ( ) , String , :upcase , [ &quot;fly&quot; ] ) #=&gt; &quot;FLY&quot; Fly.RPC . rpc_region ( :primary , String , :upcase , [ &quot;fly&quot; ] ) #=&gt; &quot;FLY&quot; Underneath the call, it's using Node.spawn_link/4 . This spawns a new process on a node in the desired region. Normally, that spawn becomes an asynchronous process and what you get back is a pid . In this case, the call executes on the other node and the caller is blocked until the result is received or the request times out. By blocking the process, this makes it much easier to reason about your application code. The following is a convenience function for performing work on the primary. Fly . rpc_primary ( String , :upcase , [ &quot;fly&quot; ] ) #=&gt; &quot;FLY&quot;","ref":"readme.html#usage","title":"Fly RPC - Usage","type":"extras"},{"doc":"When doing local development, the local and primary regions will be set to &quot;local&quot; by default. However, if you want to simulate running in a non-primary region locally, you can set the FLY_REGION and PRIMARY_REGION environment variables explicitly: FLY_REGION - Fly.io tells you which region your app is running in. PRIMARY_REGION - You tell the library which Fly.io region is your &quot;primary&quot;. When running locally, the FLY_REGION isn't set since the app isn't on Fly.io. Also, the PRIMARY_REGION set in your fly.toml file isn't being used. We just need a way to set those values when the application is running locally. I like using direnv to automatically set and load ENV values when I enter specific directories. Using direnv , you can create a file named .envrc in your project directory. Add the following lines: export FLY_REGION = xyz export PRIMARY_REGION = xyz This tells the app that it's running in the primary region. It will connect to the database and perform writes directly. Another option is to start you application like this: FLY_REGION = xyz PRIMARY_REGION = xyz iex - S mix phx . server You can also create a bash script file named start and have it perform the above command.","ref":"readme.html#local-development","title":"Fly RPC - Local Development","type":"extras"},{"doc":"Prevent temporary outages during deployments When deploying on Fly.io, a new instance is rolled out before removing the old instance. This creates a period of time where both new and old instances are deployed together. By default, when deploying a Phoenix application, a new BEAM cookie is generated for each deployment. When the new instance rolls out with a new BEAM cookie, the old and new instances will not cluster together. BEAM instances must have the same cookie in order to connect. This is by design. This means a newly deployed application running in a secondary region using fly_postgres is unable to perform writes to the older application running in the primary region. It is possible for writes to fail during that rollout window. To prevent this problem, the BEAM cookie can be explicitly set instead of randomly generated for new builds. When explicitly set, the newly deployed application is still able to connect and cluster with the older application running in the primary region. Here is a guide to setting a static cookie for your project that is written into the code itself. This is fine to do because the cookie isn't considered a secret used for security. fly.io/docs/app-guides/elixir-static-cookie/ When the cookie is static and unchanged from one deployment to the next, then applications can continue to cluster and access the applications running in primary region.","ref":"readme.html#production-environment","title":"Fly RPC - Production Environment","type":"extras"},{"doc":"[ ] Instrument with telemetry","ref":"readme.html#features","title":"Fly RPC - Features","type":"extras"}]